<?php
/*
Plugin Name: درگاه پرداخت نوینو پی برای Restrict Content Pro
Version: 1.0.0
Requires at least: 4.0
Description: درگاه پرداخت <a href="https://novinopay.com/" target="_blank"> نوینو پی </a> برای افزونه Restrict Content Pro
Plugin URI: https://novinopay.com
Author: NovinoPay
Author URI: https://novinopay.com
 */
if (!defined('ABSPATH')) {
    exit;
}
require_once 'NOVINOStd_Session.php';
if (!class_exists('RCP_NovinoPay')) {
    class RCP_NovinoPay
    {

        #webhooks
        public function process_webhooks()
        {
        }
        /**
         * Use this space to enqueue any extra JavaScript files.
         *
         * access public
         * @return void
         */
        #script
        public function scripts()
        {
        }
        /**
         * Load any extra fields on the registration form
         *
         * @access public
         * @return string
         */
        #fields
        public function fields()
        {
            /* Example for loading the credit card fields :
        ob_start();
        rcp_get_template_part( 'card-form' );
        return ob_get_clean();
         */
        }

        #validateFields
        public function validate_fields()
        {
            /* Example :
        if ( empty( $_POST['rcp_card_cvc'] ) ) {
        rcp_errors()->add( 'missing_card_code', __( 'The security code you have entered is invalid', 'rcp' ), 'register' );
        }
         */
        }

        #supports

        // public $supports = array();
        public function supports($item = '')
        {
            return;
        }

        /**
         * Generate a transaction ID
         *
         * Used in the manual payments gateway.
         *
         * @return string
         */
        public function __construct()
        {
            add_action('init', array($this, 'novinopay_Verify_By_NOVINOStd'));
            add_action('rcp_payments_settings', array($this, 'novinopay_Setting_By_NOVINOStd'));
            add_action('rcp_gateway_novinopay', array($this, 'novinopay_Request_By_NOVINOStd'));
            add_filter('rcp_payment_gateways', array($this, 'novinopay_Register_By_NOVINOStd'));
            add_filter('rcp_currencies', array($this, 'RCP_IRAN_Currencies_By_NOVINOStd'));
            add_filter('rcp_irr_currency_filter_before', array($this, 'RCP_IRR_Before_By_NOVINOStd'), 10, 3);
            add_filter('rcp_irr_currency_filter_after', array($this, 'RCP_IRR_After_By_NOVINOStd'), 10, 3);
            add_filter('rcp_irt_currency_filter_before', array($this, 'RCP_IRT_Before_By_NOVINOStd'), 10, 3);
            add_filter('rcp_irt_currency_filter_after', array($this, 'RCP_IRT_After_By_NOVINOStd'), 10, 3);
        }

        public function RCP_IRR_Before_By_NOVINOStd($formatted_price, $currency_code, $price)
        {
            return __('ریال', 'rcp') . ' ' . $price;
        }

        public function RCP_IRR_After_By_NOVINOStd($formatted_price, $currency_code, $price)
        {
            return $price . ' ' . __('ریال', 'rcp');
        }

        public function RCP_IRT_Before_By_NOVINOStd($formatted_price, $currency_code, $price)
        {
            return __('تومان', 'rcp') . ' ' . $price;
        }

        public function RCP_IRT_After_By_NOVINOStd($formatted_price, $currency_code, $price)
        {
            return $price . ' ' . __('تومان', 'rcp');
        }

        public function RCP_IRAN_Currencies_By_NOVINOStd($currencies)
        {
            unset($currencies['RIAL'], $currencies['IRR'], $currencies['IRT']);
            $iran_currencies = array(
                'IRT' => __('تومان ایران (تومان)', 'rcp'),
                'IRR' => __('ریال ایران (ریال)', 'rcp'),
            );

            return array_unique(array_merge($iran_currencies, $currencies));
        }

        public function novinopay_Register_By_NOVINOStd($gateways)
        {
            global $rcp_options;

            if (version_compare(RCP_PLUGIN_VERSION, '2.1.0', '<')) {
                $gateways['novinopay'] = isset($rcp_options['novinopay_name']) ? $rcp_options['novinopay_name'] : __('نوینو پی', 'RCP_NovinoPay');
            } else {
                $gateways['novinopay'] = array(
                    'label' => isset($rcp_options['novinopay_name']) ? $rcp_options['novinopay_name'] : __('نوینو پی', 'RCP_NovinoPay'),
                    'admin_label' => isset($rcp_options['novinopay_name']) ? $rcp_options['novinopay_name'] : __('نوینو پی', 'RCP_NovinoPay'),
                    'class' => 'RCP_NovinoPay',
                );
            }

            return $gateways;
        }

        public function novinopay_Setting_By_NOVINOStd($rcp_options)
        {
            ?>
            <hr/>
            <table class="form-table">
                <?php do_action('RCP_NovinoPay_before_settings', $rcp_options); ?>
                <tr valign="top">
                    <th colspan=2><h3><?php _e('تنظیمات نوینو پی', 'RCP_NovinoPay'); ?></h3></th>
                </tr>
                <tr valign="top">
                    <th>
                        <label for="rcp_settings[novinopay_merchant]"><?php _e('مرچنت نوینو پی', 'RCP_NovinoPay'); ?></label>
                    </th>
                    <td>
                        <input class="regular-text" id="rcp_settings[novinopay_merchant]" style="width: 300px;"
                               name="rcp_settings[novinopay_merchant]"
                               value="<?php if (isset($rcp_options['novinopay_merchant'])) {
                                   echo $rcp_options['novinopay_merchant'];
                               } ?>"/>
                    </td>
                </tr>
                <tr valign="top">
                    <th>
                        <label for="rcp_settings[novinopay_query_name]"><?php _e('نام لاتین درگاه', 'RCP_NovinoPay'); ?></label>
                    </th>
                    <td>
                        <input class="regular-text" id="rcp_settings[novinopay_query_name]" style="width: 300px;"
                               name="rcp_settings[novinopay_query_name]"
                               value="<?php echo isset($rcp_options['novinopay_query_name']) ? $rcp_options['novinopay_query_name'] : 'novinopay'; ?>"/>
                        <div class="description"><?php _e('این نام در هنگام بازگشت از بانک در آدرس بازگشت از بانک نمایان خواهد شد . از به کاربردن حروف زائد و فاصله جدا خودداری نمایید . این نام باید با نام سایر درگاه ها متفاوت باشد .', 'RCP_NovinoPay'); ?></div>
                    </td>
                </tr>
                <tr valign="top">
                    <th>
                        <label for="rcp_settings[novinopay_name]"><?php _e('نام نمایشی درگاه', 'RCP_NovinoPay'); ?></label>
                    </th>
                    <td>
                        <input class="regular-text" id="rcp_settings[novinopay_name]" style="width: 300px;"
                               name="rcp_settings[novinopay_name]"
                               value="<?php echo isset($rcp_options['novinopay_name']) ? $rcp_options['novinopay_name'] : __('نوینو پی', 'RCP_NovinoPay'); ?>"/>
                    </td>
                </tr>
                <tr valign="top">
                    <th>
                        <label><?php _e('تذکر ', 'RCP_NovinoPay'); ?></label>
                    </th>
                    <td>
                        <div class="description"><?php _e('از سربرگ مربوط به ثبت نام در تنظیمات افزونه حتما یک برگه برای بازگشت از بانک انتخاب نمایید . ترجیحا نامک برگه را لاتین قرار دهید .<br/> نیازی به قرار دادن شورت کد خاصی در برگه نیست و میتواند برگه ی خالی باشد .', 'RCP_NovinoPay'); ?></div>
                    </td>
                </tr>
                <?php do_action('RCP_NovinoPay_after_settings', $rcp_options); ?>
            </table>
            <?php
        }

        public function novinopay_Request_By_NOVINOStd($subscription_data)
        {

            $new_subscription_id = get_user_meta($subscription_data['user_id'], 'rcp_subscription_level', true);
            if (!empty($new_subscription_id)) {
                update_user_meta($subscription_data['user_id'], 'rcp_subscription_level_new', $new_subscription_id);
            }

            $old_subscription_id = get_user_meta($subscription_data['user_id'], 'rcp_subscription_level_old', true);
            update_user_meta($subscription_data['user_id'], 'rcp_subscription_level', $old_subscription_id);

            global $rcp_options;
            ob_start();
            $query = isset($rcp_options['novinopay_query_name']) ? $rcp_options['novinopay_query_name'] : 'novinopay';
            $amount = str_replace(',', '', $subscription_data['price']);
            //fee is just for paypal recurring or ipn gateway ....
            //$amount = $subscription_data['price'] + $subscription_data['fee'];

            $novinopay_payment_data = array(
                'user_id' => $subscription_data['user_id'],
                'subscription_name' => $subscription_data['subscription_name'],
                'subscription_key' => $subscription_data['key'],
                'amount' => $amount,
            );

            $NOVINOStd_session = NOVINO_Session::get_instance();
            @session_start();
            $NOVINOStd_session['novinopay_payment_data'] = $novinopay_payment_data;
            $_SESSION["novinopay_payment_data"] = $novinopay_payment_data;

            //Action For novinopay or RCP Developers...
            do_action('RCP_Before_Sending_to_novinopay', $subscription_data);

            if (in_array($rcp_options['currency'], array(
                'irt',
                'IRT',
                'تومان',
                __('تومان', 'rcp'),
                __('تومان', 'RCP_NovinoPay'),
            ))) {
                $amount = $amount * 10;
            }

            //Start of novinopay
            $MerchantID = isset($rcp_options['novinopay_merchant']) ? $rcp_options['novinopay_merchant'] : '';
            $Amount = intval($amount);
            $Email = isset($subscription_data['user_email']) ? $subscription_data['user_email'] : '-';
            $CallbackURL = add_query_arg('gateway', $query, $subscription_data['return_url']);
            $Description = sprintf(__('خرید اشتراک %s برای کاربر %s', 'RCP_NovinoPay'), $subscription_data['subscription_name'], $subscription_data['user_name']);
            $Mobile = '-';

            //Filter For novinopay or RCP Developers...
            $Description = apply_filters('RCP_NovinoPay_Description', $Description, $subscription_data);
            $Mobile = apply_filters('RCP_Mobile', $Mobile, $subscription_data);


            $data = array('merchant_id' => $MerchantID,
                'amount' => $Amount,
                'callback_url' => $CallbackURL,
                'description' => $Description);
            $jsonData = json_encode($data);
            $ch = curl_init('https://api.novinopay.com/payment/ipg/v2/request');
            curl_setopt($ch, CURLOPT_USERAGENT, 'novinopay Rest Api v2');
            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'POST');
            curl_setopt($ch, CURLOPT_POSTFIELDS, $jsonData);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array(
                'Content-Type: application/json',
                'Content-Length: ' . strlen($jsonData),
            ));
            $result = curl_exec($ch);
            $err = curl_error($ch);
            $result = json_decode($result, true);
            curl_close($ch);

            if ($result['status'] == 100) {

                ob_end_clean();
                if (!headers_sent()) {
                    header('Location: ' . $result['data']["payment_url"]);
                    exit;
                } else {

                    echo "<script type='text/javascript'>window.onload = function () { top.location.href = '" . $result['data']["payment_url"] . "'; };</script>";
                    exit;
                }
            } else {
                wp_die(sprintf(__('متاسفانه پرداخت به دلیل خطای زیر امکان پذیر نمی باشد . <br/><b> %s </b>', 'RCP_NovinoPay'), $result['message'] ?? "عدم اتصال به درگاه"));
            }
            //End of novinopay

            exit;
        }

        public function novinopay_Verify_By_NOVINOStd()
        {

            if (!isset($_GET['gateway'])) {
                return;
            }

            if (!class_exists('RCP_Payments')) {
                return;
            }

            global $rcp_options, $wpdb, $rcp_payments_db_name;
            @session_start();
            $NOVINOStd_session = NOVINO_Session::get_instance();
            if (isset($NOVINOStd_session['novinopay_payment_data'])) {
                $novinopay_payment_data = $NOVINOStd_session['novinopay_payment_data'];
            } else {
                $novinopay_payment_data = isset($_SESSION["novinopay_payment_data"]) ? $_SESSION["novinopay_payment_data"] : '';
            }

            $query = isset($rcp_options['novinopay_query_name']) ? $rcp_options['novinopay_query_name'] : 'novinopay';

            if (($_GET['gateway'] == $query) && $novinopay_payment_data) {

                $user_id = $novinopay_payment_data['user_id'];
                $user_id = intval($user_id);
                $subscription_name = $novinopay_payment_data['subscription_name'];
                $subscription_key = $novinopay_payment_data['subscription_key'];
                $amount = $novinopay_payment_data['amount'];

                /*
                $subscription_price = intval(number_format( (float) rcp_get_subscription_price( rcp_get_subscription_id( $user_id ) ), 2)) ;
                 */

                $payment_method = isset($rcp_options['novinopay_name']) ? $rcp_options['novinopay_name'] : __('نوینو پی طلایی', 'RCP_NovinoPay');

                $new_payment = 1;
                if ($wpdb->get_results($wpdb->prepare("SELECT id FROM " . $rcp_payments_db_name . " WHERE `subscription_key`='%s' AND `payment_type`='%s';", $subscription_key, $payment_method))) {
                    $new_payment = 0;
                }

                unset($GLOBALS['novinopay_new']);
                $GLOBALS['novinopay_new'] = $new_payment;
                global $new;
                $new = $new_payment;

                if ($new_payment == 1) {

                    //Start of novinopay
                    $MerchantID = isset($rcp_options['novinopay_merchant']) ? $rcp_options['novinopay_merchant'] : '';
                    $Amount = intval($amount);
                    if (in_array($rcp_options['currency'], array(
                        'irt',
                        'IRT',
                        'تومان',
                        __('تومان', 'rcp'),
                        __('تومان', 'RCP_NovinoPay'),
                    ))) {
                        $Amount = $Amount * 10;
                    }

                    $Authority = isset($_GET['Authority']) ? sanitize_text_field($_GET['Authority']) : '';

                    $__param = $Authority;
                    RCP_check_verifications(__CLASS__, $__param);

                    if (isset($_GET['PaymentStatus']) && $_GET['PaymentStatus'] == 'OK') {

                        $data = array('merchant_id' => $MerchantID, 'authority' => $Authority, 'amount' => $Amount);
                        $jsonData = json_encode($data);
                        $ch = curl_init('https://api.novinopay.com/payment/ipg/v2/verification');
                        curl_setopt($ch, CURLOPT_USERAGENT, 'novinopay Rest Api v2');
                        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'POST');
                        curl_setopt($ch, CURLOPT_POSTFIELDS, $jsonData);
                        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
                        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
                            'Content-Type: application/json',
                            'Content-Length: ' . strlen($jsonData),
                        ));
                        $result = curl_exec($ch);
                        $err = curl_error($ch);
                        curl_close($ch);
                        $result = json_decode($result, true);

                        if ($result['status'] == 100) {
                            $payment_status = 'completed';
                            $fault = 0;
                            $transaction_id = $result ['data']['ref_id'];
                        } else {
                            $payment_status = 'failed';
                            $fault = $result['message'] ?? "";
                            $transaction_id = 0;
                        }
                    } else {
                        $payment_status = 'cancelled';
                        $fault = 0;
                        $transaction_id = 0;
                    }
                    //End of novinopay

                    unset($GLOBALS['novinopay_payment_status']);
                    unset($GLOBALS['novinopay_transaction_id']);
                    unset($GLOBALS['novinopay_fault']);
                    unset($GLOBALS['novinopay_subscription_key']);
                    $GLOBALS['novinopay_payment_status'] = $payment_status;
                    $GLOBALS['novinopay_transaction_id'] = $transaction_id;
                    $GLOBALS['novinopay_subscription_key'] = $subscription_key;
                    $GLOBALS['novinopay_fault'] = $fault;
                    global $novinopay_transaction;
                    $novinopay_transaction = array();
                    $novinopay_transaction['novinopay_payment_status'] = $payment_status;
                    $novinopay_transaction['novinopay_transaction_id'] = $transaction_id;
                    $novinopay_transaction['novinopay_subscription_key'] = $subscription_key;
                    $novinopay_transaction['novinopay_fault'] = $fault;

                    if ($payment_status == 'completed') {

                        $payment_data = array(
                            'date' => date('Y-m-d g:i:s'),
                            'subscription' => $subscription_name,
                            'payment_type' => $payment_method,
                            'subscription_key' => $subscription_key,
                            'amount' => $amount,
                            'user_id' => $user_id,
                            'transaction_id' => $transaction_id,
                        );

                        //Action For novinopay or RCP Developers...
                        do_action('RCP_NovinoPay_Insert_Payment', $payment_data, $user_id);

                        $rcp_payments = new RCP_Payments();
                        RCP_set_verifications($rcp_payments->insert($payment_data), __CLASS__, $__param);

                        $new_subscription_id = get_user_meta($user_id, 'rcp_subscription_level_new', true);
                        if (!empty($new_subscription_id)) {
                            update_user_meta($user_id, 'rcp_subscription_level', $new_subscription_id);
                        }
                        $membership = (array)rcp_get_memberships()[0];
                        $old_status_level = $membership;
                        $replace = str_replace('\u0000*\u0000', '', json_encode($old_status_level));
                        $replace = json_decode($replace, true);
                        $status = $replace['status'];
                        $idMemberShip = (int)$replace['id'];
                        $arrayMember = array(
                            'status' => 'active',
                        );
                        if ($status == 'pending') {
                            rcp_update_membership($idMemberShip, $arrayMember);
                        } else {
                            rcp_set_status($user_id, 'active');
                        }

                        if (version_compare(RCP_PLUGIN_VERSION, '2.1.0', '<')) {
                            rcp_email_subscription_status($user_id, 'active');
                            if (!isset($rcp_options['disable_new_user_notices'])) {
                                wp_new_user_notification($user_id);
                            }
                        }

                        update_user_meta($user_id, 'rcp_payment_profile_id', $user_id);

                        update_user_meta($user_id, 'rcp_signup_method', 'live');
                        //rcp_recurring is just for paypal or ipn gateway
                        update_user_meta($user_id, 'rcp_recurring', 'no');

                        $subscription = rcp_get_subscription_details(rcp_get_subscription_id($user_id));
                        $member_new_expiration = date('Y-m-d H:i:s', strtotime('+' . $subscription->duration . ' ' . $subscription->duration_unit . ' 23:59:59'));
                        rcp_set_expiration_date($user_id, $member_new_expiration);
                        delete_user_meta($user_id, '_rcp_expired_email_sent');

                        $log_data = array(
                            'post_title' => __('تایید پرداخت', 'RCP_NovinoPay'),
                            'post_content' => __('پرداخت با موفقیت انجام شد . کد تراکنش : ', 'RCP_NovinoPay') . $transaction_id . __(' .  روش پرداخت : ', 'RCP_NovinoPay') . $payment_method,
                            'post_parent' => 0,
                            'log_type' => 'gateway_error',
                        );

                        $log_meta = array(
                            'user_subscription' => $subscription_name,
                            'user_id' => $user_id,
                        );

                        $log_entry = WP_Logging::insert_log($log_data, $log_meta);

                        //Action For novinopay or RCP Developers...
                        do_action('RCP_NovinoPay_Completed', $user_id);
                    }

                    if ($payment_status == 'cancelled') {

                        $log_data = array(
                            'post_title' => __('انصراف از پرداخت', 'RCP_NovinoPay'),
                            'post_content' => __('تراکنش به دلیل انصراف کاربر از پرداخت ، ناتمام باقی ماند .', 'RCP_NovinoPay') . __(' روش پرداخت : ', 'RCP_NovinoPay') . $payment_method,
                            'post_parent' => 0,
                            'log_type' => 'gateway_error',
                        );

                        $log_meta = array(
                            'user_subscription' => $subscription_name,
                            'user_id' => $user_id,
                        );

                        $log_entry = WP_Logging::insert_log($log_data, $log_meta);

                        //Action For novinopay or RCP Developers...
                        do_action('RCP_NovinoPay_Cancelled', $user_id);

                    }

                    if ($payment_status == 'failed') {

                        $log_data = array(
                            'post_title' => __('خطا در پرداخت', 'RCP_NovinoPay'),
                            'post_content' => __('تراکنش به دلیل خطای رو به رو ناموفق باقی باند :', 'RCP_NovinoPay') . $fault . __(' روش پرداخت : ', 'RCP_NovinoPay') . $payment_method,
                            'post_parent' => 0,
                            'log_type' => 'gateway_error',
                        );

                        $log_meta = array(
                            'user_subscription' => $subscription_name,
                            'user_id' => $user_id,
                        );

                        $log_entry = WP_Logging::insert_log($log_data, $log_meta);

                        //Action For novinopay or RCP Developers...
                        do_action('RCP_NovinoPay_Failed', $user_id);

                    }

                }
                add_filter('the_content', array($this, 'novinopay_Content_After_Return_By_NOVINOStd'));
                //session_destroy();
            }
        }

        public function novinopay_Content_After_Return_By_NOVINOStd($content)
        {

            global $novinopay_transaction, $new;

            $NOVINOStd_session = NOVINO_Session::get_instance();
            @session_start();

            $new_payment = isset($GLOBALS['novinopay_new']) ? $GLOBALS['novinopay_new'] : $new;

            $payment_status = isset($GLOBALS['novinopay_payment_status']) ? $GLOBALS['novinopay_payment_status'] : $novinopay_transaction['novinopay_payment_status'];
            $transaction_id = isset($GLOBALS['novinopay_transaction_id']) ? $GLOBALS['novinopay_transaction_id'] : $novinopay_transaction['novinopay_transaction_id'];
            $fault = isset($GLOBALS['novinopay_fault']) ? $GLOBALS['novinopay_fault'] : $novinopay_transaction['novinopay_fault'];

            if ($new_payment == 1) {

                $novinopay_data = array(
                    'payment_status' => $payment_status,
                    'transaction_id' => $transaction_id,
                    'fault' => $fault,
                );

                $NOVINOStd_session['novinopay_data'] = $novinopay_data;
                $_SESSION["novinopay_data"] = $novinopay_data;

            } else {
                if (isset($NOVINOStd_session['novinopay_data'])) {
                    $novinopay_payment_data = $NOVINOStd_session['novinopay_data'];
                } else {
                    $novinopay_payment_data = isset($_SESSION["novinopay_data"]) ? $_SESSION["novinopay_data"] : '';
                }

                $payment_status = isset($novinopay_payment_data['payment_status']) ? $novinopay_payment_data['payment_status'] : '';
                $transaction_id = isset($novinopay_payment_data['transaction_id']) ? $novinopay_payment_data['transaction_id'] : '';
                $fault = isset($novinopay_payment_data['fault']) ? $novinopay_payment_data['fault'] : '';
            }

            $message = '';

            if ($payment_status == 'completed') {
                $message = '<br/>' . __('پرداخت با موفقیت انجام شد . کد تراکنش : ', 'RCP_NovinoPay') . $transaction_id . '<br/>';
            }

            if ($payment_status == 'cancelled') {
                $message = '<br/>' . __('تراکنش به دلیل انصراف شما نا تمام باقی ماند .', 'RCP_NovinoPay');
            }

            if ($payment_status == 'failed') {
                $message = '<br/>' . __('تراکنش به دلیل خطای زیر ناموفق میباشد :', 'RCP_NovinoPay') . '<br/>' . $fault . '<br/>';
            }

            return $content . $message;
        }
    }
}
new RCP_NovinoPay();
if (!function_exists('change_cancelled_to_pending_By_NOVINOStd')) {
    add_action('rcp_set_status', 'change_cancelled_to_pending_By_NOVINOStd', 10, 2);
    function change_cancelled_to_pending_By_NOVINOStd($status, $user_id)
    {
        if ('cancelled' == $status) {
            rcp_set_status($user_id, 'expired');
        }

        return true;
    }
}

if (!function_exists('RCP_User_Registration_Data_By_NOVINOStd') && !function_exists('RCP_User_Registration_Data')) {
    add_filter('rcp_user_registration_data', 'RCP_User_Registration_Data_By_NOVINOStd');
    function RCP_User_Registration_Data_By_NOVINOStd($user)
    {
        $old_subscription_id = get_user_meta($user['id'], 'rcp_subscription_level', true);
        if (!empty($old_subscription_id)) {
            update_user_meta($user['id'], 'rcp_subscription_level_old', $old_subscription_id);
        }

        $user_info = get_userdata($user['id']);
        $old_user_role = implode(', ', $user_info->roles);
        if (!empty($old_user_role)) {
            update_user_meta($user['id'], 'rcp_user_role_old', $old_user_role);
        }

        return $user;
    }
}

if (!function_exists('RCP_check_verifications')) {
    function RCP_check_verifications($gateway, $params)
    {

        if (!function_exists('rcp_get_payment_meta_db_name')) {
            return;
        }

        if (is_array($params) || is_object($params)) {
            $params = implode('_', (array)$params);
        }
        if (empty($params) || trim($params) == '') {
            return;
        }

        $gateway = str_ireplace(array('RCP_', 'bank'), array('', ''), $gateway);
        $params = trim(strtolower($gateway) . '_' . $params);

        $table = rcp_get_payment_meta_db_name();

        global $wpdb;
        $check = $wpdb->get_row($wpdb->prepare("SELECT * FROM {$table} WHERE meta_key='_verification_params' AND meta_value='%s'", $params));

        if (!empty($check)) {
            wp_die('وضعیت این تراکنش قبلا مشخص شده بود.');
        }
    }
}

if (!function_exists('RCP_set_verifications')) {
    function RCP_set_verifications($payment_id, $gateway, $params)
    {

        if (!function_exists('rcp_get_payment_meta_db_name')) {
            return;
        }

        if (is_array($params) || is_object($params)) {
            $params = implode('_', (array)$params);
        }
        if (empty($params) || trim($params) == '') {
            return;
        }

        $gateway = str_ireplace(array('RCP_', 'bank'), array('', ''), $gateway);
        $params = trim(strtolower($gateway) . '_' . $params);

        $table = rcp_get_payment_meta_db_name();

        global $wpdb;
        $wpdb->insert($table, array(
            'rcp_payment_id' => $payment_id,
            'meta_key' => '_verification_params',
            'meta_value' => $params,
        ), array('%d', '%s', '%s'));
    }
}
?>
